#include <ctype.h>
#include "global.h"
#include "tolower.h"

/* I would not suggest using calls in the server. It adds a few seconds
 * per 10000 calls. This may not seem like much, but considering the
 * number of times this routine is called, it can add up
 *
 * Though a reason for having it in is as a fallout..
 */

static int calls = 0;

/* -----------------------------------------------------------------------
 * warning - only define CLIENT_COMPILE if you are compiling for the client
 * If you are not compiling the client, #undef CLIENT_COMPILE
 * NOTE: you need both _match and matches()
 * ----------------------------------------------------------------------- */

#define CLIENT_COMPILE
#undef USE_CALLS

#ifdef CLIENT_COMPILE
#  define RETURN_FALSE -1
#  define RETURN_TRUE count
#else
#  define RETURN_FALSE 1
#  define RETURN_TRUE 0
#endif

int wild_match(mask, string)
     u_char *mask, *string;
{
  register u_char *m = mask, *n = string, *ma = NULL, *na = NULL, temp;
  int just = 0;
#ifdef CLIENT_COMPILE
  u_char *pm = NULL, *pn = NULL;
  int lp_c = 0, count = 0, last_count = 0;
#endif

#ifdef USE_CALLS
  calls = 0;
#endif

  while(1)
    {

#ifdef USE_CALLS
      calls++;
#endif

      switch (*m)
	{
	case '*':
	  goto ultimate_lameness;
	  break;
#ifdef CLIENT_COMPILE
	case '%':
	  goto ultimate_lameness2;
	  break;
#endif
	case '?':
	  m++;
	  if (!*n++) return RETURN_FALSE;
	  break;
	case 0:
	  if (!*n)
	    return RETURN_TRUE;
	case '\\':
	  if ((*m=='\\') && (m[1]=='*') || (m[1]=='?')) m++;
	default:
	  if (tolower(*m) != tolower(*n))
	    return RETURN_FALSE;
	  else
	    {
#ifdef CLIENT_COMPILE
	      count++;
#endif
	      m++;
	      n++;
	    }
	}
    }

  while(1)
    {

#ifdef USE_CALLS
      calls++;
#endif

      switch (*m)
	{
	case '*':
ultimate_lameness:
	  ma = ++m;
	  na = n;
	  just = 1;
#ifdef CLIENT_COMPILE
	  last_count = count;
#endif
	  break;
#ifdef CLIENT_COMPILE
	case '%':
ultimate_lameness2:
	  pm = ++m;
	  pn = n;
	  lp_c = count;
          if (*n == ' ') pm = NULL;  /* added */
	  break;
#endif
	case '?':
	  m++;
	  if (!*n++) return RETURN_FALSE;
	  break;
	case 0:
	  if (!*n || just)
	    return RETURN_TRUE;
	case '\\':
	  if ((*m=='\\') && (m[1]=='*') || (m[1]=='?')) m++;
	default:
	  just = 0;
	  if (tolower(*m) != tolower(*n))
	    {
	      if (!*n) return RETURN_FALSE;
#ifdef CLIENT_COMPILE
	      if (pm)
		{
		  m = pm;
		  n = ++pn;
                  if (*n == ' ') pm = NULL;
		  count = lp_c;
		}
	      else
#endif	       
		if (ma)
		  {
		    m = ma;
		    n = ++na;
		    if (!*n) return RETURN_FALSE;
#ifdef CLIENT_COMPILE
		    count = last_count;
#endif
		  }
		else return RETURN_FALSE;
	    }
	  else
	    {
#ifdef CLIENT_COMPILE
	      count++;
#endif
	      m++;
	      n++;
	    }
	}
    }
}
